//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXMMAviFrame.h
 * @brief		AviFrame t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_WXMMAviFrame_H_
#define INCG_IRIS_WXMMAviFrame_H_

//======================================================================
// include
#include "WXMMAviStream.h"
#include "audio/format/AXAudioFile.h"

namespace iris {
namespace wx
{

//======================================================================
// class
/**
 * @brief	AVI Frame NX
*/
class CMMAviFrame : public INonCopyable<CMMAviFrame>
{
public:
	static const LPBITMAPINFOHEADER BESTDISPLAYFMT;
protected:
	PGETFRAME	m_pFrame;	//!< t[
public:
	// RXgN^
	CMMAviFrame(void);
	// fXgN^
	~CMMAviFrame(void);

public:
	// J
	bool	Open(PAVISTREAM pavi, LPBITMAPINFOHEADER lpbiWanted=nullptr);
	bool	IsOpen(void)	const;
	// 
	void	Close(void);

public:
	// f[^̎擾
	LPBITMAPINFOHEADER GetFrameData(s32 lPos) const;

};

}	// end of namespace wx
}	// end of namespace iris


#endif
