//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXSystemInfo.h
 * @brief		WXSystemInfo t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_WXSystemInfo_H_
#define INCG_IRIS_WXSystemInfo_H_

//======================================================================
// include
#include "iris_object.h"

namespace iris {
namespace wx
{

//======================================================================
// class
/// SYSTEM_INFO NX
class CSystemInfo : public IIrisObject
{
private:
	SYSTEM_INFO	m_Info;	//!< VXe
public:
	// RXgN^
	CSystemInfo(void);
public:
	SYSTEM_INFO&	GetOSVersionInfo(void)		{ return m_Info; }
	operator SYSTEM_INFO&	(void)				{ return m_Info; }
	SYSTEM_INFO*	operator -> (void)			{ return &m_Info; }

public:
	// 64bit OS ǂ
	bool			Is64bitOS(void) const;
	// 32bit OS ǂ
	bool			Is32bitOS(void) const;
};

}	// end of namespace wx
}	// end of namespace iris

#endif
