//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXResource.h
 * @brief		\[Xt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_WXResource_H_
#define INCG_IRIS_WXResource_H_

//======================================================================
// include
#include "iris_object.h"

namespace iris {
namespace wx
{

//======================================================================
// class
//! \[XNX
class CResource : public INonCopyable<>
{
protected:
	HRSRC	m_hRsrc;	//!< \[Xnh
	HGLOBAL	m_hMem;		//!< \[Xnh
public:
	// RXgN^
	CResource(void);
	// fXgN^
	~CResource(void);

public:
	// \[X̌
	template<typename CHARTYPE_>
	BOOL	Find(HMODULE hModule, const CHARTYPE_* lpName, const CHARTYPE_* lpType);

	// \[X̌
#if	!defined(IRIS_WIN32_WCE)
	template<typename CHARTYPE_>
	BOOL	FindEx(HMODULE hModule, const CHARTYPE_* lpName, const CHARTYPE_* lpType, WORD wLang);
#endif

	// \[X̃TCY擾
	DWORD	GetSize(HMODULE hModule) const;

	// \[X̃[h
	BOOL	Load(HMODULE hModule);

	// \[X̃bN
	LPVOID	Lock(void);
};

}	// end of namespace wx
}	// end of namespace iris

#endif
